VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "MsgHook Demo"
   ClientHeight    =   4575
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   8040
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   4575
   ScaleWidth      =   8040
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtEditor 
      Height          =   1215
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      Text            =   "DemoForm.frx":0000
      Top             =   0
      Width           =   3615
   End
   Begin VB.CommandButton cmdClearList 
      Caption         =   "Clear Event List"
      Height          =   375
      Left            =   5760
      TabIndex        =   1
      Top             =   960
      Width           =   2055
   End
   Begin VB.ListBox lstEvents 
      Height          =   2460
      Left            =   120
      TabIndex        =   0
      Top             =   1440
      Width           =   7815
   End
   Begin VB.Label Label1 
      Caption         =   "Scroll the textbox, highlight a menu item, move the window and try to resize or maximize it."
      Height          =   735
      Left            =   3960
      TabIndex        =   4
      Top             =   0
      Width           =   3735
   End
   Begin VB.Label lblStatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   4080
      Width           =   7815
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileItem 
         Caption         =   "&New"
         Index           =   0
      End
      Begin VB.Menu mnuFileItem 
         Caption         =   "&Open"
         Index           =   1
      End
      Begin VB.Menu mnuFileItem 
         Caption         =   "&Save"
         Index           =   2
      End
      Begin VB.Menu mnuFileItem 
         Caption         =   "-"
         Index           =   3
      End
      Begin VB.Menu mnuFileItem 
         Caption         =   "E&xit"
         Index           =   4
      End
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "(popup)"
      Visible         =   0   'False
      Begin VB.Menu mnuPopupItem 
         Caption         =   "Clear the textbox"
         Index           =   0
      End
      Begin VB.Menu mnuPopupItem 
         Caption         =   "Save to file"
         Index           =   1
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Implements IMsgHookEvents

Dim WithEvents FormHook As MsgHook
Attribute FormHook.VB_VarHelpID = -1
Dim TextBoxHook As MsgHook
Attribute TextBoxHook.VB_VarHelpID = -1

Private Sub Form_Load()
    ' form subclassing uses events
    Set FormHook = New MsgHook
    FormHook.StartSubclass hWnd
    ' textbox subclassing uses IMsgHookEvents secondary interface
    Set TextBoxHook = New MsgHook
    TextBoxHook.StartSubclass txtEditor.hWnd, Me
End Sub

Private Sub cmdClearList_Click()
    lstEvents.Clear
End Sub

' Add an item to the event list.

Private Sub ShowEvent(text As String)
    lstEvents.AddItem text
    lstEvents.ListIndex = lstEvents.ListCount - 1
End Sub

Private Sub FormHook_BeforeMessage(uMsg As Long, wParam As Long, lParam As Long, retValue As Long, Cancel As Boolean)
    Select Case uMsg
        Case WM_PAINT
            ' Windows is requesting the window to repaint itself
            Dim lpRect As RECT
            GetUpdateRect Me.hWnd, lpRect, False
            With lpRect
                'ShowEvent "About to repaint rectangle (" & .Left & "," & .Top & ")-(" & .Right & "," & .Bottom & ")"
            End With
    End Select
End Sub

Private Sub FormHook_AfterMessage(ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long, retValue As Long)
    Select Case uMsg
        Case WM_MOVE
            ' The form has moved.
            ShowEvent "Move"
        Case WM_ACTIVATEAPP
            ' The application has been activated or deactivated.
            If wParam Then
                ShowEvent "The application is being activated"
            Else
                ShowEvent "The application is being deactivated"
            End If
        Case WM_DISPLAYCHANGE
            ' The screen resolution has changed.
            ShowEvent "Screen resolution has changed"
        Case WM_TIMECHANGE
            ' System date/time has changed.
            ShowEvent "System time has changed"
        Case WM_COMPACTING
            ' Windows is low in memory (release resources if possible).
            ShowEvent "Windows is compacting memory"
        Case WM_QUERYOPEN
            ' The iconized form is being restored.
            ShowEvent "The iconized window is about to be restored"
            ' Uncomment the next line to prevent the window from being restored.
            ' retValue = False
        Case WM_GETMINMAXINFO
            ' Windows is querying the form for its
            ' minimum and maximum size and position.
            Dim mmInfo As MINMAXINFO
            ' Read contents of structure pointed to by lParam.
            CopyMemory mmInfo, ByVal lParam, Len(mmInfo)
            With mmInfo
                ' ptMaxSize is the size of the maximized form.
                .ptMaxSize.X = 600
                .ptMaxSize.Y = 400
                ' ptMaxPosition is the position of the maximized form.
                .ptMaxPosition.X = ((Screen.Width / Screen.TwipsPerPixelX) - 600) \ 2
                .ptMaxPosition.Y = ((Screen.Height / Screen.TwipsPerPixelY) - 400) \ 2
                ' ptMinTrackSize is the minimum size of a form when resizing with the mouse.
                .ptMinTrackSize.X = 300
                .ptMinTrackSize.Y = 200
                ' ptMinTrackSize is the maximum size of a form when resizing with the mouse.
                ' (It is usually equal to ptMaxSize.)
                .ptMaxTrackSize.X = 600
                .ptMaxTrackSize.Y = 400
            End With
            ' Copy back in the original structure in memory.
            CopyMemory ByVal lParam, mmInfo, Len(mmInfo)
            ' Must return zero to inform that the structure has been modified.
            retValue = 0
        Case WM_COMMAND
            ' The user selects a command item from a menu,
            ' or a control sends a notification message to its parent window,
            ' or an accelerator keystroke is translated.
            
            ' If this is a notification from a control, lParam holds its handle.
            
            If lParam = txtEditor.hWnd Then
                ' In this case, the notification message is in the
                ' high-order word of wParam.
                ' NOTE: this msg doesn't arrive if the scroll bar indicator is scrolled.
                Select Case (wParam \ &H10000)
                    Case EN_HSCROLL
                        ShowEvent "The TextBox control has been scrolled horizontally"
                    Case EN_VSCROLL
                        ShowEvent "The TextBox control has been scrolled vertically"
                End Select
            End If
        Case WM_MENUSELECT
            ' A menu has been selected (but not clicked yet).
            ' The menu item identifier is in the low-order word of wParam.
            ' The menu handle is in lParam
            Dim menuId As Long, menuCaption As String, length As Long, menuDescr As String
            menuId = (wParam And &HFFFF&)
            ' Get the menu caption
            menuCaption = Space$(256)
            length = GetMenuString(lParam, menuId, menuCaption, Len(menuCaption), 0)
            menuCaption = Left$(menuCaption, length)
            
            Select Case menuCaption
                Case "&New"
                    menuDescr = "Create a new file"
                Case "&Open"
                    menuDescr = "Open an existing file"
                Case "&Save"
                    menuDescr = "Save a file to disk"
                Case "E&xit"
                    menuDescr = "Exit the program"
            End Select
            lblStatus = menuDescr

    End Select
End Sub

Private Sub IMsgHookEvents_AfterMessage(ByVal obj As MsgHookSvr.MsgHook, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ReturnValue As Long)
    ' not used
End Sub

Private Sub IMsgHookEvents_BeforeMessage(ByVal obj As MsgHookSvr.MsgHook, uMsg As Long, wParam As Long, lParam As Long, ReturnValue As Long, Cancel As Boolean)
    ' in this particular case, it isn't necessary to test for
    ' hWnd, because we are subclassing only the txtEditor
    If obj.hWnd = txtEditor.hWnd Then
        If uMsg = WM_CONTEXTMENU Then
            ' Show a custom popup menu.
            PopupMenu mnuPopup
            ' Cancel the default processing
            ' (i.e. don't display the default context menu).
            Cancel = True
        End If
    End If
End Sub

Private Sub mnuPopupItem_Click(Index As Integer)
    MsgBox "Custom context menu for TextBox controls!", vbExclamation
End Sub

